using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;
using Infragistics;
using System.Collections.Generic;

namespace PullDownAndLoadMore
{
	public partial class PullDownAndLoadMoreViewController : UIViewController
	{
		IGGridView gridView;
		IGGridViewDataSourceHelper dsh;

		public PullDownAndLoadMoreViewController () : base ("PullDownAndLoadMoreViewController", null)
		{
		}


		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			List<TestData> data = new List<TestData> ();
			for (int i = 0; i < 50; i++) {
				TestData td = new TestData () { Prop1 = i.ToString() };
				data.Add (td);

			}

			gridView = new IGGridView (new RectangleF (0, 0, this.View.Frame.Size.Width, this.View.Frame.Size.Height), IGGridViewStyle.IGGridViewStyleDefault);

			dsh = new IGGridViewDataSourceHelper ();
			dsh.WeakLoadMoreDelegate = new LoadMore (gridView);

			dsh.Data = data.ToArray();


			gridView.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
			this.View.AddSubview(gridView);
			gridView.RowBackgroundColor = UIColor.White;
			gridView.ColumnWidth = IGColumnWidth.CreateNumericColumnWidth (200);
			gridView.WeakDelegate = new MyDelegate ();

			gridView.DataSource = dsh;

		}
	}

	public class MyDelegate : IGGridViewDelegate
	{
		public override void UpdateRequested (IGGridView gridView)
		{
			gridView.FinishedUpdating ();
		}
	}

	public class LoadMore : IGGridViewDataSourceHelperLoadMoreDelegate
	{
		IGGridView _gridView;

		public LoadMore(IGGridView grid)
		{
			_gridView = grid;
		}

		public override IGGridViewLoadMoreCell ResolveLoadMoreCell (IGGridView gridView)
		{
			IGGridViewLoadMoreCell cell = (IGGridViewLoadMoreCell)gridView.DequeueReusableCell ("LoadMore");

			if (cell == null)
				cell = new IGGridViewLoadMoreCell ("LoadMore");

			return cell;
		}

		public override bool NeedMoreRows (IGGridViewDataSourceHelper dataSource)
		{
			return dataSource.Data.Length <2000;
		}

		public override void LoadMoreRows (IGGridViewDataSourceHelper dataSource)
		{
			int currentCount = dataSource.Data.Length;
			List<NSObject> data = new List<NSObject> ((NSObject[])dataSource.Data);
			for (int i = currentCount; i < (currentCount + 100); i++) {
				TestData td = new TestData () { Prop1 = i.ToString() };
				data.Add (td);

			}
			//Rebind the datasource
			dataSource.Data = data.ToArray ();

			//Update the display
			_gridView.UpdateData ();

		}
	}



	public class TestData :NSObject
	{
		[Export("prop1")]
		public string Prop1 {
			get;
			set;
		}
		[Export("prop2")]
		public string Prop2 {
			get{ return Prop1;}
		}
		[Export("prop3")]
		public string Prop3 {
			get{ return Prop1;}
		}
		[Export("prop4")]
		public string Prop4 {
			get{ return Prop1;}
		}
		[Export("prop5")]
		public string Prop5 {
			get{ return Prop1;}
		}
		[Export("prop6")]
		public string Prop6 {
			get{ return Prop1;}
		}
		[Export("prop7")]
		public string Prop7 {
			get{ return Prop1;}
		}
		[Export("prop8")]
		public string Prop8 {
			get{ return Prop1;}
		}
		[Export("prop9")]
		public string Prop9 {
			get{ return Prop1;}
		}
		[Export("prop10")]
		public string Prop10 {
			get{ return Prop1;}
		}
		[Export("prop11")]
		public string Prop11 {
			get{ return Prop1;}
		}
		[Export("prop12")]
		public string Prop12 {
			get{ return Prop1;}
		}
		[Export("prop13")]
		public string Prop13 {
			get{ return Prop1;}
		}
		[Export("prop14")]
		public string Prop14 {
			get{ return Prop1;}
		}

	}
}

